Update x86 and x86_64 kernel images [DO NOT MERGE] automerge: baaba1db6d  -s ours
automerge: 1e01450b8b  -s ours

* commit '1e01450b8b9f8d31364eeb1e7b454d2c663184b7':
  Update x86 and x86_64 kernel images [DO NOT MERGE]
diff --git a/arm64/kernel-qemu b/arm64/kernel-qemu
index 40e7a15..028de35 100755
--- a/arm64/kernel-qemu
+++ b/arm64/kernel-qemu
Binary files differ
diff --git a/build-kernel.sh b/build-kernel.sh
new file mode 100755
index 0000000..beb5984
--- /dev/null
+++ b/build-kernel.sh
@@ -0,0 +1,433 @@
+#!/bin/sh
+#
+# A small script used to rebuild the Android goldfish kernel image
+# See docs/KERNEL.TXT for usage instructions.
+#
+
+export LANG=C
+export LC_ALL=C
+
+PROGNAME=$(basename "$0")
+
+MACHINE=goldfish
+VARIANT=goldfish
+OUTPUT=/tmp/kernel-qemu
+CROSSPREFIX=arm-linux-androideabi-
+CONFIG=goldfish
+GCC_VERSION=4.8
+
+VALID_ARCHS="arm x86 x86_64 mips arm64 mips64"
+
+# Determine the host architecture, and which default prebuilt tag we need.
+# For the toolchain auto-detection.
+#
+HOST_OS=`uname -s`
+case "$HOST_OS" in
+    Darwin)
+        HOST_OS=darwin
+        HOST_TAG=darwin-x86
+        BUILD_NUM_CPUS=$(sysctl -n hw.ncpu)
+        ;;
+    Linux)
+        # note that building  32-bit binaries on x86_64 is handled later
+        HOST_OS=linux
+        HOST_TAG=linux-x86
+        BUILD_NUM_CPUS=$(grep -c processor /proc/cpuinfo)
+        ;;
+    *)
+        echo "ERROR: Unsupported OS: $HOST_OS"
+        exit 1
+esac
+
+# Default number of parallel jobs during the build: cores * 2
+JOBS=$(( $BUILD_NUM_CPUS * 2 ))
+
+ARCH=arm
+
+OPTION_HELP=no
+OPTION_ARMV7=yes
+OPTION_OUT=
+OPTION_CROSS=
+OPTION_ARCH=
+OPTION_CONFIG=
+OPTION_SAVEDEFCONFIG=no
+OPTION_JOBS=
+OPTION_VERBOSE=
+OPTION_GCC_VERSION=
+CCACHE=
+
+case "$USE_CCACHE" in
+    "")
+        CCACHE=
+        ;;
+    *)
+        # use ccache bundled in AOSP source tree
+        CCACHE=${ANDROID_BUILD_TOP:-$(dirname $0)/../..}/prebuilts/misc/$HOST_TAG/ccache/ccache
+        [ -x $CCACHE ] || CCACHE=
+        ;;
+esac
+
+for opt do
+    optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
+    case $opt in
+    --help|-h|-\?) OPTION_HELP=yes
+        ;;
+    --arch=*)
+        OPTION_ARCH=$optarg
+        ;;
+    --armv5)
+        OPTION_ARMV7=no
+        ;;
+    --armv7)
+        OPTION_ARMV7=yes
+        ;;
+    --ccache=*)
+        CCACHE=$optarg
+        ;;
+    --config=*)
+        OPTION_CONFIG=$optarg
+        ;;
+    --cross=*)
+        OPTION_CROSS=$optarg
+        ;;
+    --gcc-version=*)
+        OPTION_GCC_VERSION=$optarg
+        ;;
+    -j*|--jobs=*)
+        OPTION_JOBS=$optarg
+        ;;
+    --out=*)
+        OPTION_OUT=$optarg
+        ;;
+    --savedefconfig)
+        OPTION_SAVEDEFCONFIG=yes
+        ;;
+    --verbose)
+        OPTION_VERBOSE=true
+        ;;
+    *)
+        echo "unknown option '$opt', use --help"
+        exit 1
+    esac
+done
+
+if [ $OPTION_HELP = "yes" ] ; then
+    echo "Rebuild the prebuilt kernel binary for Android's emulator."
+    echo ""
+    echo "options (defaults are within brackets):"
+    echo ""
+    echo "  --help                   print this message"
+    echo "  --arch=<arch>            change target architecture [$ARCH]"
+    echo "  --armv5                  build ARMv5 binaries"
+    echo "  --armv7                  build ARMv7 binaries (default. see note below)"
+    echo "  --out=<directory>        output directory [$OUTPUT]"
+    echo "  --cross=<prefix>         cross-toolchain prefix [$CROSSPREFIX]"
+    echo "  --config=<name>          kernel config name [$CONFIG]"
+    echo "  --savedefconfig          run savedefconfig"
+    echo "  --ccache=<path>          use compiler cache [${CCACHE:-not set}]"
+    echo "  --gcc-version=<version>  use specific GCC version [$GCC_VERSION]"
+    echo "  --verbose                show build commands"
+    echo "  -j<number>               launch <number> parallel build jobs [$JOBS]"
+    echo ""
+    echo "NOTE: --armv7 is equivalent to --config=goldfish_armv7. It is"
+    echo "      ignored if --config=<name> is used."
+    echo ""
+    exit 0
+fi
+
+if [ ! -f include/linux/vermagic.h ]; then
+    echo "ERROR: You must be in the top-level kernel source directory to run this script."
+    exit 1
+fi
+
+# Extract kernel version, we'll need to put this in the final binaries names
+# to ensure the emulator can trivially know it without probing the binary with
+# 'file' or other unreliable heuristics.
+KERNEL_MAJOR=$(awk '$1 == "VERSION" { print $3; }' Makefile)
+KERNEL_MINOR=$(awk '$1 == "PATCHLEVEL" { print $3; }' Makefile)
+KERNEL_PATCH=$(awk '$1 == "SUBLEVEL" { print $3; }' Makefile)
+KERNEL_VERSION="$KERNEL_MAJOR.$KERNEL_MINOR.$KERNEL_PATCH"
+echo "Found kernel version: $KERNEL_VERSION"
+
+if [ -n "$OPTION_ARCH" ]; then
+    ARCH=$OPTION_ARCH
+fi
+
+if [ -n "$OPTION_GCC_VERSION" ]; then
+    GCC_VERSION=$OPTION_GCC_VERSION
+else
+    if [ "$ARCH" = "x86" ]; then
+        # Work-around a nasty bug.
+        # Hence 132637 is 2.6.29.
+        if [ "$KERNEL_VERSION" = "2.6.29" ]; then
+            GCC_VERSION=4.6
+            echo "WARNING: android-goldfish-$KERNEL_VERSION doesn't build --arch=$ARCH with GCC 4.7"
+        fi
+    fi
+    if [ "$ARCH" = "arm64" ]; then
+        # There is no GCC 4.7 toolchain to build AARCH64 binaries.
+        GCC_VERSION=4.8
+    fi
+    if [ "$ARCH" = "mips64" ]; then
+        GCC_VERSION=4.9
+    fi
+    echo "Autoconfig: --gcc-version=$GCC_VERSION"
+fi
+
+if [ -n "$OPTION_CONFIG" ]; then
+    CONFIG=$OPTION_CONFIG
+else
+    case $ARCH in
+        arm)
+            CONFIG=goldfish_armv7
+            if  [ "$OPTION_ARMV7" = "no" ]; then
+                CONFIG=goldfish
+            fi
+            ;;
+        x86)
+            # Warning: this is ambiguous, should be 'goldfish' before 3.10,
+            # and 'i386_emu" after it.
+            if [ -f "arch/x86/configs/i386_emu_defconfig" ]; then
+                CONFIG=i386_emu
+            else
+                CONFIG=goldfish
+            fi
+            ;;
+        x86_64)
+            CONFIG=x86_64_emu
+            ;;
+        mips)
+            CONFIG=goldfish
+            ;;
+        mips64)
+            CONFIG=ranchu64
+            ;;
+        arm64)
+            CONFIG=ranchu
+            ;;
+        *)
+            echo "ERROR: Invalid arch '$ARCH', try one of $VALID_ARCHS"
+            exit 1
+    esac
+    echo "Auto-config: --config=$CONFIG"
+fi
+
+# Check output directory.
+if [ -n "$OPTION_OUT" ] ; then
+    if [ ! -d "$OPTION_OUT" ] ; then
+        echo "Output directory '$OPTION_OUT' does not exist ! Aborting."
+        exit 1
+    fi
+    OUTPUT=$OPTION_OUT
+else
+    OUTPUT=$OUTPUT/${ARCH}-${KERNEL_VERSION}
+    case $CONFIG in
+        vbox*)
+            OUTPUT=${OUTPUT}-vbox
+            ;;
+        goldfish)
+            if [ "$ARCH" = "arm" ]; then
+                OUTPUT=${OUTPUT}-armv5
+            fi
+            ;;
+    esac
+    echo "Auto-config: --out=$OUTPUT"
+    mkdir -p $OUTPUT
+fi
+
+if [ -n "$OPTION_CROSS" ] ; then
+    CROSSPREFIX="$OPTION_CROSS"
+    CROSSTOOLCHAIN=${CROSSPREFIX}$GCC_VERSION
+else
+    case $ARCH in
+        arm)
+            CROSSPREFIX=arm-linux-androideabi-
+            ;;
+        x86)
+            CROSSPREFIX=x86_64-linux-android-
+            # NOTE: kernel-toolchain/toolbox.sh will add -m32
+            ;;
+        x86_64)
+            CROSSPREFIX=x86_64-linux-android-
+            ;;
+        mips)
+            CROSSPREFIX=mipsel-linux-android-
+            ;;
+        mips64)
+            CROSSPREFIX=mips64el-linux-android-
+            ;;
+        arm64)
+            CROSSPREFIX=aarch64-linux-android-
+            ;;
+        *)
+            echo "ERROR: Unsupported architecture!"
+            exit 1
+            ;;
+    esac
+    CROSSTOOLCHAIN=${CROSSPREFIX}$GCC_VERSION
+    echo "Auto-config: --cross=$CROSSPREFIX"
+fi
+
+ZIMAGE=zImage
+
+case $ARCH in
+    x86|x86_64)
+        ZIMAGE=bzImage
+        ;;
+    arm64)
+        ZIMAGE=Image
+        ;;
+    mips)
+        ZIMAGE=
+        ;;
+    mips64)
+        ZIMAGE=
+        ;;
+esac
+
+# If the cross-compiler is not in the path, try to find it automatically
+CROSS_COMPILER="${CROSSPREFIX}gcc"
+CROSS_COMPILER_VERSION=$($CROSS_COMPILER --version 2>/dev/null)
+if [ $? != 0 ] ; then
+    BUILD_TOP=$ANDROID_BUILD_TOP
+    if [ -z "$BUILD_TOP" ]; then
+        # Assume this script is under external/qemu/distrib/ in the
+        # Android source tree.
+        BUILD_TOP=$(dirname $0)/../..
+        if [ ! -d "$BUILD_TOP/prebuilts" ]; then
+            BUILD_TOP=
+        else
+            BUILD_TOP=$(cd $BUILD_TOP && pwd)
+        fi
+    fi
+    case $ARCH in
+        x86_64)
+            # x86_46 binaries are under prebuilts/gcc/<host>/x86 !!
+            PREBUILT_ARCH=x86
+            ;;
+        arm64)
+            PREBUILT_ARCH=aarch64
+            ;;
+        mips64)
+            PREBUILT_ARCH=mips
+            ;;
+        *)
+            PREBUILT_ARCH=$ARCH
+            ;;
+    esac
+    CROSSPREFIX=$BUILD_TOP/prebuilts/gcc/$HOST_TAG/$PREBUILT_ARCH/$CROSSTOOLCHAIN/bin/$CROSSPREFIX
+    echo "Checking for ${CROSSPREFIX}gcc"
+    if [ "$BUILD_TOP" -a -f ${CROSSPREFIX}gcc ]; then
+        echo "Auto-config: --cross=$CROSSPREFIX"
+    else
+        echo "It looks like $CROSS_COMPILER is not in your path ! Aborting."
+        exit 1
+    fi
+fi
+
+if [ "$CCACHE" ] ; then
+    echo "Using ccache program: $CCACHE"
+    CROSSPREFIX="$CCACHE $CROSSPREFIX"
+fi
+
+export CROSS_COMPILE="$CROSSPREFIX" ARCH SUBARCH=$ARCH
+
+if [ "$OPTION_JOBS" ]; then
+    JOBS=$OPTION_JOBS
+else
+    echo "Auto-config: -j$JOBS"
+fi
+
+
+# Special magic redirection with our magic toolbox script
+# This is needed to add extra compiler flags to compiler.
+# See kernel-toolchain/android-kernel-toolchain-* for details
+#
+export REAL_CROSS_COMPILE="$CROSS_COMPILE"
+CROSS_COMPILE=$(dirname "$0")/kernel-toolchain/android-kernel-toolchain-
+
+MAKE_FLAGS=
+if [ "$OPTION_VERBOSE" ]; then
+  MAKE_FLAGS="$MAKE_FLAGS V=1"
+fi
+
+case $CONFIG in
+    defconfig)
+        MAKE_DEFCONFIG=$CONFIG
+        ;;
+    *)
+        MAKE_DEFCONFIG=${CONFIG}_defconfig
+        ;;
+esac
+
+ORG_ARCH=$ARCH
+case $ARCH in
+    mips64)
+        # MIPS64 Kernel code base is under arch/mips
+        ARCH=mips
+        ;;
+esac
+
+# Do the build
+#
+rm -f include/asm &&
+make $MAKE_DEFCONFIG &&    # configure the kernel
+make -j$JOBS $MAKE_FLAGS       # build it
+
+if [ $? != 0 ] ; then
+    echo "Could not build the kernel. Aborting !"
+    exit 1
+fi
+
+if [ "$OPTION_SAVEDEFCONFIG" = "yes" ]; then
+    case $ARCH in
+        x86_64)
+            DEFCONFIG_ARCH=x86
+            ;;
+        *)
+            DEFCONFIG_ARCH=$ARCH
+            ;;
+    esac
+    make savedefconfig
+    mv -f defconfig arch/$DEFCONFIG_ARCH/configs/${CONFIG}_defconfig
+fi
+
+# Note: The exact names of the output files are important for the Android build,
+#       do not change the definitions lightly.
+KERNEL_PREFIX=kernel-$KERNEL_VERSION
+
+# Naming conventions for the kernel image files:
+#
+#   1) The kernel image is called kernel-qemu, except for 32-bit ARM
+#      where it must be called kernel-qemu-armv7
+#
+#   2) The debug symbol file is called vmlinux-qemu, except for 32-bit
+#      ARM where it must be called vmlinux-qemu-armv7
+#
+OUTPUT_KERNEL=kernel-qemu
+OUTPUT_VMLINUX=vmlinux-qemu
+if [ "$CONFIG" = "goldfish_armv7" ]; then
+    OUTPUT_KERNEL=${OUTPUT_KERNEL}-armv7
+    OUTPUT_VMLINUX=${OUTPUT_VMLINUX}-armv7
+fi
+
+cp -f vmlinux $OUTPUT/$OUTPUT_VMLINUX
+if [ ! -z $ZIMAGE ]; then
+    cp -f arch/$ARCH/boot/$ZIMAGE $OUTPUT/$OUTPUT_KERNEL
+else
+    cp -f vmlinux $OUTPUT/$OUTPUT_KERNEL
+fi
+echo "Kernel $CONFIG prebuilt images ($OUTPUT_KERNEL and $OUTPUT_VMLINUX) copied to $OUTPUT successfully !"
+
+cp COPYING $OUTPUT/LINUX_KERNEL_COPYING
+
+cat > $OUTPUT/README <<EOF
+This directory contains kernel images to be used with the Android emulator
+program, for the $ORG_ARCH CPU architecture. It was built with the $PROGNAME
+script. For more details, read:
+
+  \$AOSP/external/qemu/docs/ANDROID-KERNEL.TXT
+
+EOF
+
+exit 0
diff --git a/kernel-toolchain/android-kernel-toolchain-ar b/kernel-toolchain/android-kernel-toolchain-ar
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-ar
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-as b/kernel-toolchain/android-kernel-toolchain-as
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-as
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-gcc b/kernel-toolchain/android-kernel-toolchain-gcc
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-gcc
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-ld b/kernel-toolchain/android-kernel-toolchain-ld
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-ld
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-nm b/kernel-toolchain/android-kernel-toolchain-nm
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-nm
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-objcopy b/kernel-toolchain/android-kernel-toolchain-objcopy
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-objcopy
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-objdump b/kernel-toolchain/android-kernel-toolchain-objdump
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-objdump
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-ranlib b/kernel-toolchain/android-kernel-toolchain-ranlib
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-ranlib
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-size b/kernel-toolchain/android-kernel-toolchain-size
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-size
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/android-kernel-toolchain-strip b/kernel-toolchain/android-kernel-toolchain-strip
new file mode 120000
index 0000000..dc0b8a0
--- /dev/null
+++ b/kernel-toolchain/android-kernel-toolchain-strip
@@ -0,0 +1 @@
+toolbox.sh
\ No newline at end of file
diff --git a/kernel-toolchain/toolbox.sh b/kernel-toolchain/toolbox.sh
new file mode 100755
index 0000000..ddee4bd
--- /dev/null
+++ b/kernel-toolchain/toolbox.sh
@@ -0,0 +1,58 @@
+#!/bin/sh
+#
+# This is a wrapper around our toolchain that allows us to add a few
+# compiler flags.
+# The issue is that our toolchain are NDK-compatible, and hence enforces
+# -fpic (and also -mfpmath=sse for x86) by default.  When building the
+# kernel, we need to disable this.
+#
+# Also support ccache compilation if USE_CCACHE is defined as "1"
+#
+
+# REAL_CROSS_COMPILE must be defined, and its value must be one of the
+# CROSS_COMPILE values that are supported by the Kernel build system
+# (e.g. "i686-linux-android-")
+#
+if [ -z "$REAL_CROSS_COMPILE" ]; then
+    echo "ERROR: The REAL_CROSS_COMPILE environment variable should be defined!"
+    exit 1
+fi
+
+# ARCH must also be defined before calling this script, e.g. 'arm' or 'x86'
+#
+if [ -z "$ARCH" ]; then
+    echo "ERROR: ARCH must be defined!"
+    exit 1
+fi
+
+# Common prefix for all fake toolchain programs, which are all really
+# symlinks to this script, i.e.
+#
+# $PROGPREFIX-gcc  --> $0
+# $PROGPREFIX-ld   --> $0
+# etc...
+#
+PROGPREFIX=android-kernel-toolchain-
+
+# Get program name, must be of the form $PROGPREFIX-<suffix>, where
+# <suffix> can be 'gcc', 'ld', etc... We expect that the fake toolchain
+# files are all symlinks to this script.
+#
+PROGNAME=$(basename "$0")
+PROGSUFFIX=${PROGNAME##$PROGPREFIX}
+
+EXTRA_FLAGS=
+
+if [ "$PROGSUFFIX" = gcc ]; then
+    # Special case #1: For all, disable PIC code
+    EXTRA_FLAGS=$EXTRA_FLAGS" -fno-pic"
+    case $ARCH in
+        x86)
+            # Special case #2: For x86, disable SSE FPU arithmetic too
+            EXTRA_FLAGS=$EXTRA_FLAGS" -m32 -mfpmath=387"
+            ;;
+    esac
+fi
+
+# Invoke real cross-compiler toolchain program now
+${REAL_CROSS_COMPILE}$PROGSUFFIX $EXTRA_FLAGS "$@"
diff --git a/mips64/LINUX_KERNEL_COPYING b/mips64/LINUX_KERNEL_COPYING
new file mode 100644
index 0000000..ca442d3
--- /dev/null
+++ b/mips64/LINUX_KERNEL_COPYING
@@ -0,0 +1,356 @@
+
+   NOTE! This copyright does *not* cover user programs that use kernel
+ services by normal system calls - this is merely considered normal use
+ of the kernel, and does *not* fall under the heading of "derived work".
+ Also note that the GPL below is copyrighted by the Free Software
+ Foundation, but the instance of code that it refers to (the Linux
+ kernel) is copyrighted by me and others who actually wrote it.
+
+ Also note that the only valid version of the GPL as far as the kernel
+ is concerned is _this_ particular version of the license (ie v2, not
+ v2.2 or v3.x or whatever), unless explicitly otherwise stated.
+
+			Linus Torvalds
+
+----------------------------------------
+
+		    GNU GENERAL PUBLIC LICENSE
+		       Version 2, June 1991
+
+ Copyright (C) 1989, 1991 Free Software Foundation, Inc.
+                       51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ Everyone is permitted to copy and distribute verbatim copies
+ of this license document, but changing it is not allowed.
+
+			    Preamble
+
+  The licenses for most software are designed to take away your
+freedom to share and change it.  By contrast, the GNU General Public
+License is intended to guarantee your freedom to share and change free
+software--to make sure the software is free for all its users.  This
+General Public License applies to most of the Free Software
+Foundation's software and to any other program whose authors commit to
+using it.  (Some other Free Software Foundation software is covered by
+the GNU Library General Public License instead.)  You can apply it to
+your programs, too.
+
+  When we speak of free software, we are referring to freedom, not
+price.  Our General Public Licenses are designed to make sure that you
+have the freedom to distribute copies of free software (and charge for
+this service if you wish), that you receive source code or can get it
+if you want it, that you can change the software or use pieces of it
+in new free programs; and that you know you can do these things.
+
+  To protect your rights, we need to make restrictions that forbid
+anyone to deny you these rights or to ask you to surrender the rights.
+These restrictions translate to certain responsibilities for you if you
+distribute copies of the software, or if you modify it.
+
+  For example, if you distribute copies of such a program, whether
+gratis or for a fee, you must give the recipients all the rights that
+you have.  You must make sure that they, too, receive or can get the
+source code.  And you must show them these terms so they know their
+rights.
+
+  We protect your rights with two steps: (1) copyright the software, and
+(2) offer you this license which gives you legal permission to copy,
+distribute and/or modify the software.
+
+  Also, for each author's protection and ours, we want to make certain
+that everyone understands that there is no warranty for this free
+software.  If the software is modified by someone else and passed on, we
+want its recipients to know that what they have is not the original, so
+that any problems introduced by others will not reflect on the original
+authors' reputations.
+
+  Finally, any free program is threatened constantly by software
+patents.  We wish to avoid the danger that redistributors of a free
+program will individually obtain patent licenses, in effect making the
+program proprietary.  To prevent this, we have made it clear that any
+patent must be licensed for everyone's free use or not licensed at all.
+
+  The precise terms and conditions for copying, distribution and
+modification follow.
+
+		    GNU GENERAL PUBLIC LICENSE
+   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION
+
+  0. This License applies to any program or other work which contains
+a notice placed by the copyright holder saying it may be distributed
+under the terms of this General Public License.  The "Program", below,
+refers to any such program or work, and a "work based on the Program"
+means either the Program or any derivative work under copyright law:
+that is to say, a work containing the Program or a portion of it,
+either verbatim or with modifications and/or translated into another
+language.  (Hereinafter, translation is included without limitation in
+the term "modification".)  Each licensee is addressed as "you".
+
+Activities other than copying, distribution and modification are not
+covered by this License; they are outside its scope.  The act of
+running the Program is not restricted, and the output from the Program
+is covered only if its contents constitute a work based on the
+Program (independent of having been made by running the Program).
+Whether that is true depends on what the Program does.
+
+  1. You may copy and distribute verbatim copies of the Program's
+source code as you receive it, in any medium, provided that you
+conspicuously and appropriately publish on each copy an appropriate
+copyright notice and disclaimer of warranty; keep intact all the
+notices that refer to this License and to the absence of any warranty;
+and give any other recipients of the Program a copy of this License
+along with the Program.
+
+You may charge a fee for the physical act of transferring a copy, and
+you may at your option offer warranty protection in exchange for a fee.
+
+  2. You may modify your copy or copies of the Program or any portion
+of it, thus forming a work based on the Program, and copy and
+distribute such modifications or work under the terms of Section 1
+above, provided that you also meet all of these conditions:
+
+    a) You must cause the modified files to carry prominent notices
+    stating that you changed the files and the date of any change.
+
+    b) You must cause any work that you distribute or publish, that in
+    whole or in part contains or is derived from the Program or any
+    part thereof, to be licensed as a whole at no charge to all third
+    parties under the terms of this License.
+
+    c) If the modified program normally reads commands interactively
+    when run, you must cause it, when started running for such
+    interactive use in the most ordinary way, to print or display an
+    announcement including an appropriate copyright notice and a
+    notice that there is no warranty (or else, saying that you provide
+    a warranty) and that users may redistribute the program under
+    these conditions, and telling the user how to view a copy of this
+    License.  (Exception: if the Program itself is interactive but
+    does not normally print such an announcement, your work based on
+    the Program is not required to print an announcement.)
+
+These requirements apply to the modified work as a whole.  If
+identifiable sections of that work are not derived from the Program,
+and can be reasonably considered independent and separate works in
+themselves, then this License, and its terms, do not apply to those
+sections when you distribute them as separate works.  But when you
+distribute the same sections as part of a whole which is a work based
+on the Program, the distribution of the whole must be on the terms of
+this License, whose permissions for other licensees extend to the
+entire whole, and thus to each and every part regardless of who wrote it.
+
+Thus, it is not the intent of this section to claim rights or contest
+your rights to work written entirely by you; rather, the intent is to
+exercise the right to control the distribution of derivative or
+collective works based on the Program.
+
+In addition, mere aggregation of another work not based on the Program
+with the Program (or with a work based on the Program) on a volume of
+a storage or distribution medium does not bring the other work under
+the scope of this License.
+
+  3. You may copy and distribute the Program (or a work based on it,
+under Section 2) in object code or executable form under the terms of
+Sections 1 and 2 above provided that you also do one of the following:
+
+    a) Accompany it with the complete corresponding machine-readable
+    source code, which must be distributed under the terms of Sections
+    1 and 2 above on a medium customarily used for software interchange; or,
+
+    b) Accompany it with a written offer, valid for at least three
+    years, to give any third party, for a charge no more than your
+    cost of physically performing source distribution, a complete
+    machine-readable copy of the corresponding source code, to be
+    distributed under the terms of Sections 1 and 2 above on a medium
+    customarily used for software interchange; or,
+
+    c) Accompany it with the information you received as to the offer
+    to distribute corresponding source code.  (This alternative is
+    allowed only for noncommercial distribution and only if you
+    received the program in object code or executable form with such
+    an offer, in accord with Subsection b above.)
+
+The source code for a work means the preferred form of the work for
+making modifications to it.  For an executable work, complete source
+code means all the source code for all modules it contains, plus any
+associated interface definition files, plus the scripts used to
+control compilation and installation of the executable.  However, as a
+special exception, the source code distributed need not include
+anything that is normally distributed (in either source or binary
+form) with the major components (compiler, kernel, and so on) of the
+operating system on which the executable runs, unless that component
+itself accompanies the executable.
+
+If distribution of executable or object code is made by offering
+access to copy from a designated place, then offering equivalent
+access to copy the source code from the same place counts as
+distribution of the source code, even though third parties are not
+compelled to copy the source along with the object code.
+
+  4. You may not copy, modify, sublicense, or distribute the Program
+except as expressly provided under this License.  Any attempt
+otherwise to copy, modify, sublicense or distribute the Program is
+void, and will automatically terminate your rights under this License.
+However, parties who have received copies, or rights, from you under
+this License will not have their licenses terminated so long as such
+parties remain in full compliance.
+
+  5. You are not required to accept this License, since you have not
+signed it.  However, nothing else grants you permission to modify or
+distribute the Program or its derivative works.  These actions are
+prohibited by law if you do not accept this License.  Therefore, by
+modifying or distributing the Program (or any work based on the
+Program), you indicate your acceptance of this License to do so, and
+all its terms and conditions for copying, distributing or modifying
+the Program or works based on it.
+
+  6. Each time you redistribute the Program (or any work based on the
+Program), the recipient automatically receives a license from the
+original licensor to copy, distribute or modify the Program subject to
+these terms and conditions.  You may not impose any further
+restrictions on the recipients' exercise of the rights granted herein.
+You are not responsible for enforcing compliance by third parties to
+this License.
+
+  7. If, as a consequence of a court judgment or allegation of patent
+infringement or for any other reason (not limited to patent issues),
+conditions are imposed on you (whether by court order, agreement or
+otherwise) that contradict the conditions of this License, they do not
+excuse you from the conditions of this License.  If you cannot
+distribute so as to satisfy simultaneously your obligations under this
+License and any other pertinent obligations, then as a consequence you
+may not distribute the Program at all.  For example, if a patent
+license would not permit royalty-free redistribution of the Program by
+all those who receive copies directly or indirectly through you, then
+the only way you could satisfy both it and this License would be to
+refrain entirely from distribution of the Program.
+
+If any portion of this section is held invalid or unenforceable under
+any particular circumstance, the balance of the section is intended to
+apply and the section as a whole is intended to apply in other
+circumstances.
+
+It is not the purpose of this section to induce you to infringe any
+patents or other property right claims or to contest validity of any
+such claims; this section has the sole purpose of protecting the
+integrity of the free software distribution system, which is
+implemented by public license practices.  Many people have made
+generous contributions to the wide range of software distributed
+through that system in reliance on consistent application of that
+system; it is up to the author/donor to decide if he or she is willing
+to distribute software through any other system and a licensee cannot
+impose that choice.
+
+This section is intended to make thoroughly clear what is believed to
+be a consequence of the rest of this License.
+
+  8. If the distribution and/or use of the Program is restricted in
+certain countries either by patents or by copyrighted interfaces, the
+original copyright holder who places the Program under this License
+may add an explicit geographical distribution limitation excluding
+those countries, so that distribution is permitted only in or among
+countries not thus excluded.  In such case, this License incorporates
+the limitation as if written in the body of this License.
+
+  9. The Free Software Foundation may publish revised and/or new versions
+of the General Public License from time to time.  Such new versions will
+be similar in spirit to the present version, but may differ in detail to
+address new problems or concerns.
+
+Each version is given a distinguishing version number.  If the Program
+specifies a version number of this License which applies to it and "any
+later version", you have the option of following the terms and conditions
+either of that version or of any later version published by the Free
+Software Foundation.  If the Program does not specify a version number of
+this License, you may choose any version ever published by the Free Software
+Foundation.
+
+  10. If you wish to incorporate parts of the Program into other free
+programs whose distribution conditions are different, write to the author
+to ask for permission.  For software which is copyrighted by the Free
+Software Foundation, write to the Free Software Foundation; we sometimes
+make exceptions for this.  Our decision will be guided by the two goals
+of preserving the free status of all derivatives of our free software and
+of promoting the sharing and reuse of software generally.
+
+			    NO WARRANTY
+
+  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY
+FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN
+OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES
+PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED
+OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS
+TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE
+PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,
+REPAIR OR CORRECTION.
+
+  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING
+WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR
+REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,
+INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING
+OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED
+TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY
+YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER
+PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE
+POSSIBILITY OF SUCH DAMAGES.
+
+		     END OF TERMS AND CONDITIONS
+
+	    How to Apply These Terms to Your New Programs
+
+  If you develop a new program, and you want it to be of the greatest
+possible use to the public, the best way to achieve this is to make it
+free software which everyone can redistribute and change under these terms.
+
+  To do so, attach the following notices to the program.  It is safest
+to attach them to the start of each source file to most effectively
+convey the exclusion of warranty; and each file should have at least
+the "copyright" line and a pointer to where the full notice is found.
+
+    <one line to give the program's name and a brief idea of what it does.>
+    Copyright (C) <year>  <name of author>
+
+    This program is free software; you can redistribute it and/or modify
+    it under the terms of the GNU General Public License as published by
+    the Free Software Foundation; either version 2 of the License, or
+    (at your option) any later version.
+
+    This program is distributed in the hope that it will be useful,
+    but WITHOUT ANY WARRANTY; without even the implied warranty of
+    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+    GNU General Public License for more details.
+
+    You should have received a copy of the GNU General Public License
+    along with this program; if not, write to the Free Software
+    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+
+Also add information on how to contact you by electronic and paper mail.
+
+If the program is interactive, make it output a short notice like this
+when it starts in an interactive mode:
+
+    Gnomovision version 69, Copyright (C) year name of author
+    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
+    This is free software, and you are welcome to redistribute it
+    under certain conditions; type `show c' for details.
+
+The hypothetical commands `show w' and `show c' should show the appropriate
+parts of the General Public License.  Of course, the commands you use may
+be called something other than `show w' and `show c'; they could even be
+mouse-clicks or menu items--whatever suits your program.
+
+You should also get your employer (if you work as a programmer) or your
+school, if any, to sign a "copyright disclaimer" for the program, if
+necessary.  Here is a sample; alter the names:
+
+  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
+  `Gnomovision' (which makes passes at compilers) written by James Hacker.
+
+  <signature of Ty Coon>, 1 April 1989
+  Ty Coon, President of Vice
+
+This General Public License does not permit incorporating your program into
+proprietary programs.  If your program is a subroutine library, you may
+consider it more useful to permit linking proprietary applications with the
+library.  If this is what you want to do, use the GNU Library General
+Public License instead of this License.
diff --git a/mips64/README b/mips64/README
new file mode 100644
index 0000000..8a751ca
--- /dev/null
+++ b/mips64/README
@@ -0,0 +1,6 @@
+This directory contains kernel images to be used with the Android emulator
+program, for the mips64 CPU architecture. It was built with the build-kernel.sh
+script. For more details, read:
+
+  $AOSP/external/qemu/docs/ANDROID-KERNEL.TXT
+
diff --git a/mips64/kernel-qemu b/mips64/kernel-qemu
new file mode 100755
index 0000000..d1d6317
--- /dev/null
+++ b/mips64/kernel-qemu
Binary files differ